<?php
/**
 * @package     Divshare Embeder Plugin
 * @version     1.1
 * @author      Stergios Zgouletas <info@web-expert.gr>
 * @link        http://www.web-expert.gr
 * @copyright   Copyright (C) 2010 Web-Expert.gr All Rights Reserved
 * @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class plgSystemWe_Divshare extends JPlugin{
	
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onAfterRender() {
		$app = &JFactory::getApplication();
		$doc = &JFactory::getDocument();
		$docType = $doc->getType();
		if ($docType != 'html'  || $app->isAdmin() ) return true;
		
		$sitecode = JResponse::getBody();
		$pos = JString::strpos($sitecode, "<body");
		$text=$sitecode;
		if($pos > 0){
			$head = substr($sitecode, 0, $pos);
			$text = substr($sitecode, $pos);
		}
		
		// check if is used to content
		if (JString::strpos($text, '{divshare}') === false) {
			return true;
		}
		
		$regex = '/{divshare}(.*){\/divshare}/iU';

		// check whether plugin has been unpublished
		if ( !$this->params->def( 'enabled', 1 ) ) {
			$text = preg_replace( $regex, '', $text);
			return true;
		}

		
		preg_match_all( $regex, $text, $matches );
		if ( count( $matches[0] )<1 ) return true;
		
		//Get Params
		$dftype=$this->params->def( 'defaulttype', 'audio' );
		$awidth=$this->params->def( 'awidth', 335 );
		$aheight=$this->params->def( 'aheight', 28 );
		$vwidth=$this->params->def( 'vwidth', 425 );
		$vheight=$this->params->def( 'vheight', 374 );	
		
		for ( $i=0; $i <count( $matches[0] ); $i++ )
		{
			$tagparams = explode('|',$matches[1][$i]);
			//Let's see what parameters we have
			
			if(count($tagparams)==4){
				$type=strtolower($tagparams[0]);
				$width=$tagparams[1];
				$height=$tagparams[2];
				$id=$tagparams[3];
			}

			if(count($tagparams)==3){
				$type=$dftype;
				$width=$tagparams[0];
				$height=$tagparams[1];
				$id=$tagparams[2];
			}

			if(count($tagparams)==2){
				$type=strtolower($tagparams[0]);
				if($type=="audio"){
					$width=$awidth;
					$height=$aheight;
				}else{
					$width=$vwidth;
					$height=$vheight;
				}
				$id=$tagparams[1];
			}

			if(count($tagparams)==1){
				$type=$dftype;
				if($type=="audio"){
					$width=$awidth;
					$height=$aheight;
				}else{
					$width=$vwidth;
					$height=$vheight;
				}
				$id=$tagparams[0];
			}
			
			if(count($tagparams)>0){
				//Get embeded
				$divshare = $this->render($id,$width,$height,$type);
				$replace=$divshare;
				
				//Generate Link
				if ($this->params->def( 'ddlink', 1 )){
					$downloadlink = $this->download($id,$this->params->def('target',''),$type);
					$replace=$divshare." ".$downloadlink;
				}
			}else{
				$replace='<!-- divshare no parameters are defined -->';
			}
			
			//replace the tags with content
			$text = preg_replace( $regex,'<div class="divshare">'.$replace.'</div>',$text, 1);
		}
		if($pos > 0){
			$text=$head.$text;
		}
		JResponse::setBody($text);
	}
	
	function render($id,$width,$height,$type){
		switch($type){
			case 'audio':
				$html='<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0" ';
				$html.='width="'.$width.'" height="'.$height.'" id="divplaylist">';
				$html.='<param name="movie" value="http://www.divshare.com/flash/playlist?myId='.$id.'" />';
				$html.='<embed src="http://www.divshare.com/flash/playlist?myId='.$id.'" ';
				$html.='width="'.$width.'" height="'.$height.'" name="divplaylist" type="application/x-shockwave-flash" ';
				$html.='pluginspage="http://www.macromedia.com/go/getflashplayer"></embed></object>';
				break;
			case 'video':
			default:
				$html='<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,18,0" width="'.$width.'" height="'.$height.'" id="divflv">';
				$html.='<param name="movie" value="http://www.divshare.com/flash/video?myId='.$id.'" />';
				$html.='<param name="allowFullScreen" value="true" />';
				$html.='<embed src="http://www.divshare.com/flash/video?myId='.$id.'" width="'.$width.'" height="'.$height.'" name="divflv" allowfullscreen="true" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer">';
				$html.='</embed></object>';
				break;
		}
		return $html;
	}

	function download($id, $target,$type) {
		$patern="http://www.divshare.com/download/launch/";
		
		switch($type){
			case 'audio':
				$html='<a title="Download" target="_'.trim($target).'" href="'.$patern.$id.'"><img src="'.JURI::root().'plugins/system/we_divshare/download.gif" /></a>';
				break;
			case 'video':
			default:
				$html='<br/><a title="Download" target="_'.trim($target).'" href="'.$patern.$id.'">Download Video</a>';
				break;
		}
		return $html;
	}
}
?>